var ImageViewer = (function($) {
	
	var IViewer = function() {
		
		var viewer = $('<div class="arivoc-image-viewer">' +
							'<div class="close-x"></div>' +
							'<div class="image-box"></div>' +
							'<canvas width="3000" height="1000"></canvas>' +
							'<div class="controlbar">' +
								'<span class="icon brush"></span>' +
								'<span class="icon rubber"></span>' +
								'<span class="icon zoomout"></span>' +
								'<span class="icon zoomin"></span>' +
								'<span class="icon rotate"></span>' +
								'<div class="brush-tools">' +
									'<div class="dot-list">' +
										'<span class="dot small" value="1"></span>' +
										'<span class="dot normal on" value="3"></span>' +
										'<span class="dot big" value="6"></span>' +
									'</div>' +
									'<div class="color-list">' +
										'<span class="color-block red on" value="#FF0000"></span>' +
										'<span class="color-block green" value="#29CC29"></span>' +
									'</div>' +
								'</div>' +
								'<div class="rubber-tools">' +
									'<div class="dot-list">' +
										'<span class="dot small on" mouse="rs" value="16"></span>' +
										'<span class="dot normal" mouse="rm" value="20"></span>' +
										'<span class="dot big" mouse="rl" value="24"></span>' +
									'</div>' +
									'<div class="clean-btn">清空</div>' +
								'</div>' +
							'</div>' +
						'</div>');
						
		var userAgent = navigator.userAgent.toLocaleLowerCase();
		var isIE = userAgent.indexOf("trident") > -1;
		var IEVer = parseInt(userAgent.substr(userAgent.indexOf("msie") + 5, 4));
		var isIE78 = (IEVer == 7 || IEVer == 8);
		
		var imgurl = null;
		var onHideFun = null;
		var zoomout = 0.8;
		var zoomin = 1.25;
		var rotate = 0;
		var brush = 8;
		var brushColor = "#FF0000";
		var rubber = 8;
		var rubberMouse = "rs";
		var mouseTop = isIE ? 32 : 0;
		
		var canvas = null, context = null;
		
		function initialize(imageurl, onHide) {
			
			imgurl = imageurl;
			onHideFun = onHide;
			rotate = 0;
			brush = parseInt(viewer.find(".brush-tools .dot.on").attr("value"));
			brushColor = viewer.find(".brush-tools .color-block.on").attr("value");
			rubber = parseInt(viewer.find(".rubber-tools .dot.on").attr("value"));
			rubberMouse = viewer.find(".rubber-tools .dot.on").attr("mouse");
			
			viewer.find(".image-box").empty().append("<img class='image' src='" + imgurl + "' />");
			
			viewer.find(".close-x").unbind("click").bind("click", remove);
			viewer.find(".icon.brush").unbind("click").bind("click", onBrush);
			viewer.find(".icon.rubber").unbind("click").bind("click", onRubber);
			viewer.find(".icon.zoomout").unbind("click").bind("click", onZoomout);
			viewer.find(".icon.zoomin").unbind("click").bind("click", onZoomin);
			viewer.find(".icon.rotate").unbind("click").bind("click", onRotate);
			
			viewer.find(".brush-tools .dot-list .dot").unbind("click").bind("click", onBrushDot);
			viewer.find(".brush-tools .color-list .color-block").unbind("click").bind("click", onBrushColor);
			viewer.find(".rubber-tools .dot-list .dot").unbind("click").bind("click", onRubberDot);
			viewer.find(".rubber-tools .clean-btn").unbind("click").bind("click", cleanCanvas);
			
			viewer.find(".icon.on").trigger("click");
			
			initCanvas();
		}
		
		function initCanvas() {
			if (isIE78) {
				canvas = new Object(), context = new Object();
				return;
			}
			canvas = viewer.find("canvas").get(0);
			context = canvas.getContext("2d");
			context.clearRect(0, 0, canvas.width, canvas.height);
			canvas.onmousedown = null;
		}
		
		function remove() {
			viewer.remove();
			if (!!onHideFun) {
				onHideFun();
			}
		}
		
		function onBrush() {
			$(this).siblings(".icon.on").trigger("click");
			$(this).toggleClass("on");
			if ($(this).hasClass("on")) {
				viewer.find(".brush-tools").show();
				canvas.onmousedown = onCanvasBrushDown;
				viewer.find("canvas").addClass("brush-mode");
			} else {
				viewer.find(".brush-tools").hide();
				canvas.onmousedown = null;
				viewer.find("canvas").removeClass("brush-mode");
			}
		}
		function onRubber() {
			$(this).siblings(".icon.on").trigger("click");
			$(this).toggleClass("on");
			if ($(this).hasClass("on")) {
				viewer.find(".rubber-tools").show();
				canvas.onmousedown = onCanvasRubberDown;
				viewer.find("canvas").addClass("rubber-mode " + rubberMouse);
			} else {
				viewer.find(".rubber-tools").hide();
				canvas.onmousedown = null;
				viewer.find("canvas").removeClass("rubber-mode " + rubberMouse);
			}
		}
		function onZoomout() {
			var w = viewer.find(".image").width();
			var h = viewer.find(".image").height();
			if (isIE78) {
				viewer.find(".image-box").empty().append("<img class='image' src='" + imgurl + "' />");
			}
			if ((w / h) > (window.innerWidth / window.innerHeight)) {
				viewer.find(".image").width(w * zoomout);
				viewer.find(".image").height("auto");
			} else {
				viewer.find(".image").width("auto");
				viewer.find(".image").height(h * zoomout);
			}
			viewer.find(".image").rotate(rotate);
		}
		function onZoomin() {
			var w = viewer.find(".image").width();
			var h = viewer.find(".image").height();
			if (isIE78) {
				viewer.find(".image-box").empty().append("<img class='image' src='" + imgurl + "' />");
			}
			if ((w / h) > (window.innerWidth / window.innerHeight)) {
				viewer.find(".image").width(w * zoomin);
				viewer.find(".image").height("auto");
			} else {
				viewer.find(".image").width("auto");
				viewer.find(".image").height(h * zoomin);
			}
			viewer.find(".image").rotate(rotate);
		}
		function onRotate() {
			rotate += 90;
			viewer.find(".image").rotate(rotate);
		}
		
		function onBrushDot() {
			$(this).addClass("on").siblings(".dot").removeClass("on");
			brush = parseInt(viewer.find(".brush-tools .dot.on").attr("value"));
		}
		function onBrushColor() {
			$(this).addClass("on").siblings(".color-block").removeClass("on");
			brushColor = viewer.find(".brush-tools .color-block.on").attr("value");
		}
		function onRubberDot() {
			$(this).addClass("on").siblings(".dot").removeClass("on");
			rubber = parseInt(viewer.find(".rubber-tools .dot.on").attr("value"));
			rubberMouse = viewer.find(".rubber-tools .dot.on").attr("mouse");
			
			viewer.find("canvas").removeClass("rs rm rl").addClass(rubberMouse);
		}
		function cleanCanvas() {
			context.clearRect(0, 0, canvas.width, canvas.height);
		}
		
		function onCanvasBrushDown(evt) {
			context.beginPath();
			context.lineWidth = brush;
			context.strokeStyle = brushColor;
			context.moveTo(evt.clientX - canvas.offsetLeft, evt.clientY - canvas.offsetTop - mouseTop);
			document.onmousemove = onCanvasBrushMove;
			document.onmouseup = onCanvasBrushUp;
		}
		function onCanvasBrushMove(evt) {
			context.lineTo(evt.clientX - canvas.offsetLeft, evt.clientY - canvas.offsetTop - mouseTop);
			context.stroke();
		}
		function onCanvasBrushUp(evt) {
			document.onmousemove = null;
			document.onmouseup = null;
		}
		
		function onCanvasRubberDown(evt) {
			document.onmousemove = onCanvasRubberMove;
			document.onmouseup = onCanvasRubberUp;
		}
		function onCanvasRubberMove(evt) {
			var x = evt.clientX - canvas.offsetLeft;
			var y = evt.clientY - canvas.offsetTop - mouseTop;
			var w = rubber, h = rubber;
			context.clearRect(x, y, w, h);
		}
		function onCanvasRubberUp(evt) {
			document.onmousemove = null;
			document.onmouseup = null;
		}
		
		this.show = function(imageurl, onHide) {
			initialize(imageurl, onHide);
			$("body").append(viewer);
		};
		
	};
	
	return IViewer;
	
})(jQuery);