(function($) {
	
	$.fn.examTextShow = function(option) {
		return this.each(function() {
			var ets = new ExamTextShow(this, option);
			$(this).data("exam-text-show", ets);
		});
	};
	
	var ExamTextShow = function(container, option) {
		
		var NOFUN = function() {};
		
		var defaultOption = {
			onOpened: NOFUN,
			onClosed: NOFUN,
			onAnswerChecked: NOFUN,
			onAnswerUncheck: NOFUN
		};
		
		var config = $.extend({}, defaultOption, option);
		
		var content = $('<div class="exam-text-show">' +
							'<div class="title">' +
								'<input class="text-checker" type="checkbox" />&nbsp;<span>显示文本</span>' +
								'&nbsp;&nbsp;&nbsp;&nbsp;' +
								'<input class="answer-checker" type="checkbox" />&nbsp;<span>显示答案</span>' +
								'<div class="full"></div>' +
							'</div>' +
							'<textarea readonly="readonly"></textarea>' +
						'</div>');
		
		$(container).append(content);
		
		content.find(".text-checker").bind("change", function() {
			if ($(this).is(":checked")) {
				config.onOpened();
				content.find("textarea").show();
			} else {
				config.onClosed();
				content.find("textarea").hide();
			}
		});
		content.find(".answer-checker").bind("change", function() {
			if ($(this).is(":checked")) {
				config.onAnswerChecked();
			} else {
				config.onAnswerUncheck();
			}
		});
		
		this.loadText = function(val) {
			content.find("textarea").val(val);
		};
		
		this.clear = function() {
			content.find("textarea").scrollTop(0).val("");
			content.find(".answer-checker").prop("checked", false);
			content.find(".text-checker").prop("checked", false).trigger("change");
		};
	};
	
})(jQuery);
